;EnG
.nolist
#define TASM
#define bcall(xxxx)     rst 28h \ .dw xxxx
#define equ .equ
#define    LCDDelay()   .db $DB,$10,$87,$38,$FB
#include   "..\..\EnG.inc"
.list
        .org 9D93h
        .db $BB,$6D
  ;first, we make awesomeness by checking the number of free RAM pages

     in a,(6)
     ld (iy+34),a
     ld c,a
     ld hl,4000h
     ld d,l       ;d is 0
     ld b,6
     ld a,80h
     inc a
     out (6),a
RamPageCountLoop:
     ld (hl),a
     inc a
     out (6),a
     ld (hl),a
     dec a
     out (6),a
     cp (hl)       ;z means extra RAM page
     jr nz,$+3
     inc d
     djnz RamPageCountLoop-3
;d is the number of extra RAM pages
     ld (iy+33),d
     inc d
     dec d
     jr z,Start
       ld a,82h
       out (6),a
       ld a,(4000h)
       sub 82h
       sub d
       jr nc,ResetERAM
       ld hl,(4002h)
       ld a,h
       sub 40h
       jr c,ResetERAM
       sub 40h
       jr c,Start
ResetERAM:
       ld a,82h
       ld (4001h),a
       ld hl,ExtraRAM
       ld (4002h),hl
Start:
     ld a,c
     out (6),a
     ld hl,(4002h)
     ld (hl),-1
     bcall(4AD7h)     ;RclAns
     or a
     jr nz,$+10
;Real Input
     ld (ArgLoc),hl
     ld hl,1
     jr ParseList
     ex de,hl
CheckList:
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld (ArgLoc),hl
     ex de,hl
     dec a
     jr z,ParseList
     sub 3
     jp z,ParseString
     sub 9
     add hl,hl
ParseList:
     ld (ArgCount),hl
;     in a,(6)
;     ld (iy+34),a
     call Parse-4
     ld a,(iy+34)
     out (6),a
     ret
     ld (SPSave),sp
Parse:
     call LoadIncrement
     ret z
     ld hl,Parse
     push hl
     ex de,hl
     add hl,hl
     ld bc,CommandTableEnd-CommandTable
     sbc hl,bc
     add hl,bc
     jr c,$+5
       ld hl,CommandTableEnd-CommandTable-2
     ld bc,CommandTable
     add hl,bc
     ld e,(hl)
     inc hl
     ld d,(hl)
     ld a,e \ or d
     jr nz,$+5
       ld de,UpdateLCD
     push de
     ret
ClrDraw:
   ;0.x = ClrDraw, no LCD update
   ;  x is the backup buffer to use
   ;    0   = 9340h
   ;    1   = 86ECh
   ;    2   = 9872h
   ;    3+n = 8080h+768n on the extra RAM page
     ld d,0
     call CheckDigit1

     push de
     call GetBuffer
     pop de
     ret nz
     ld bc,3
       ld (hl),d
       inc hl
       djnz $-2
       dec c
       jr nz,$-5
     ret
FillBufBlack:
     ld d,-1
     call CheckDigit2
     jr ClrDraw+5
FillBufInv:
     call CheckDigit2
     call GetBuffer
     ret nz
     ld bc,3
       ld a,(hl)
       cpl
       ld (hl),a
       inc hl
       djnz $-4
       dec c
       jr nz,$-7
     ret
DrawHexSprite:
     call LocateStr1
     push hl
     push bc
     srl b
     rr c
     push bc
     ld d,h
     ld e,l
       dec hl
       ld (hl),b
       dec hl
       ld (hl),c
       inc hl
       inc hl
       call HexTok
       pop bc
       pop de
       ex de,hl
       or a
       sbc hl,bc
       ex de,hl
       bcall(4357h)
       jr DrawSprite+4
HexTok:
       call GetHexAtDE
       call GetHexAtDE
       cpi
       jp pe,HexTok
       ret
GetHexAtDE:
     ld a,(de)
     cp 3Ah
     jr c,$+4
     sub 7
     inc de
     rld
     ret
DrawSprite:
     call LocateStr1
     push hl \ pop ix
     call CheckDigit2
     push af
     call CheckDigit3
     ld d,a                ;width
     jr nz,$+3
       inc d
     call CheckDigit4
     ld e,a                ;Height
     jr nz,$+4
       ld e,8
     push de
     call CheckDigit5
     call GetBuffer
     ld (TempWord1),hl
     call LoadIncrement
     push de
     call LoadIncrement
     pop bc
     ld b,a
     pop de
     pop hl
DrawLargeSprite:
;Inputs:
;     B is the Y coordinate
;     C is the X coordinate
;     D is the width (in bytes) of tyhe sprite
;     E is the height of the sprite
;     H is the method
;        0=Overwrite
;        1=AND
;        2=XOR
;        3=OR
;        4=Erase
;     IX points to the sprite data
     ld a,c
     and 7
     srl c
     srl c
     srl c
     ld (TempWord2),bc
     ld bc,0C40h
DrawSpriteLarge2:
;     A is the shift amount
;     B is the max width to cut off
;     C is the max height of the sprite
;     D is height
;     E is width
;     H is the type
;     IX points to the sprite data
;     (TempWord2+1)=Y (pixel)
;     (TempWord2)=X (byte)
;     (TempWord1) is the buf
     push hl
     dec h
     ld hl,TSBG
     ld (hl),0
     jr nz,$+4
     ld (hl),-1
SMC_OutSprite:
     ld hl,86ECh                  ;output sprite location. 966Eh if <128 bytes, else 86ECh
     call TransformSprite
     pop af    ;A is the type
     ld de,(TempWord2+1)
     ld d,0
     push hl
     ld h,d
     ld l,e
     add hl,de
     add hl,de
     add hl,hl
     add hl,hl
     ld de,(TempWord2)
     ld d,0
     add hl,de
     ld de,(TempWord1)
     add hl,de
     pop de
     bit 2,(iy+35)
     jr z,$+4
       dec b
       ret z
     res 1,(iy+35)
DrawSpriteXxY:
;
;Inputs:
;     A is the method
;     B is the width (in bytes)
;     C is the height (in pixels)
;     DE points to the sprite data
;     HL points to the output location
;Outputs:
;     HL is A*12 larger (next sprite down?)
;     DE points to the next byte after the sprite data
;     A is 0
;     B is not changed
;     C is 12-B
;
       push af             ; push af 
       ld a,c              ;79
;       di                  ;F3
       ex af,af'           ;08
       ld a,12             ;3E0C
       sub b               ;90
       ld c,a              ;4F
       pop af              ;\ pop af 
OverwriteXxY:
       or a                ; or a 
       jr nz,ANDXxY        ;2010
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-4            ;10FA         
           add hl,bc           ;09
           bit 2,(iy+35)
           jr z,$+3
           inc de
           pop af              ;
           pop bc              ;
           dec a               ;3D
           jr nz,$-19          ;20F2
         res 2,(iy+35)
         ret                 ;C9
ANDXxY:
       dec a               ;3D
       jr nz,XORXxY        ;2011
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             and (hl)            ;A6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-13          ;20\ pop af 
         ret                 ;C9
XORXxY:
       dec a               ;3D
       jr nz,ORXxY         ;2011
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             xor (hl)            ;AE
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-13          ;20\ pop af 
         ret                 ;C9
ORXxY:
       dec a               ;3D
       jr nz,EraseXxY
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             or (hl)             ;B6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
         add hl,bc           ;09
         pop af              ;\ pop af 
         pop bc              ;\ pop bc 
         dec a               ;3D
         jr nz,$-13          ;20F1 
         ret                 ;C9
EraseXxY:
         dec a               ;3D
         ret nz
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             cpl                 ;2F
             and (hl)            ;A6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-6            ;10F8
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-14          ;20F0
         ret                 ;C9
TransformSprite:
;Inputs:
;     A is the number of shifts to perform
;     B is the max width in bytes to cut off
;     C is the max height in pixels to cut off
;     D is the byte width of the sprite
;     E is the pixel height of the sprite
;     HL is the buffer to copy to.
;     IX points to the sprite data
;     (TSBG) is 00 for white, FF for black
;Output:
;     B is the byte width adjusted
;     C is the adjusted height
;     DE is zero
;     HL points to the sprite data
;     di
     push bc
     ex af,af'
     ld a,b
     ex af,af'
     ld b,a
     ld a,d
     exx
     ld de,(TSBG-1)
     pop bc
     inc a
     sub b
     exx

     res 1,(iy+35)
     jr nc,$+3
     xor a
     jr z,$+7
       set 1,(iy+35)
       dec a
     ld c,a
     ld a,e
     exx
     cp c
     jr c,$+3
       ld a,c
     exx
     ld e,a
     push bc
     push hl
     ld b,0
TSLoop1:
     push de
     push de
     ex af,af'
     ld e,a
     ex af,af'
     ld a,(ix)
     ld (hl),a
     inc ix
     inc hl
     dec e
     jr z,$+5
     dec d
     jr nz,TSLoop1+5
     add ix,bc
     ld a,e
     or a
     jr z,$+7
       exx
       ld a,d
       exx
       ld (hl),a
       inc hl
     pop de
     dec e
     jr nz,TSLoop1+1
     pop de
     pop hl
     pop bc
;At this point, the sprite is copied to the buffer
;Now its data can be shifted
;A' is the max width
     ld a,d
     exx
     cp b
     exx
     jr c,$+5
     ex af,af'
     ld d,a
     ex af,af'

     push de
     ld a,b
     or a
     jr z,TSExit
TSLoop2:
     push de
     push hl
     push bc
     push de
     exx
     rlc d
     exx
       rr (hl)
       inc hl
       dec d
       jr nz,$-4
     bit 1,(iy+35)
     jr nz,$+5
     rr (hl)
     inc hl
     pop de
     dec e
     jr nz,TSLoop2+3
     pop bc
     pop hl
     pop de
     djnz TSLoop2
TSExit:
     pop bc
     bit 1,(iy+35)
     jr z,$+6
       res 2,(iy+35)
     res 1,(iy+35)
     ld a,b
     exx
     cp b
     exx
     ret nc
     inc b
     ret
Misc:
     call CheckDigit2
     cp 8
     jr nz,$+9
       xor (iy+5)
       ld (iy+5),a
       ret

     rra
     set 3,(iy+36)
     jr nc,$+6
     res 3,(iy+36)

     rra
     set 1,(iy+5)
     jr nc,$+6
     res 1,(iy+5)

     rra
     push af
     bcall(4570h)
     pop af
     ret nc
     bcall(456Dh)
     ret
ShiftScreen:
     call CheckDigit2
     call GetBuffer
     ld (TempWord1),hl
     call LoadIncrement
     or a
     ret z
     push de
     call LoadIncrement
     pop bc
ShiftGraphBuf:
       ld b,4
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphDownA
       pop af
       pop bc
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphLeftA
       pop af
       pop bc
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphRightA
       pop af
       pop bc
        rrca
        ld a,c
       ret nc
ShiftGraphUpA:
     ld e,a
     ld l,a
     ld h,0
     ld d,h
     add hl,hl
     add hl,de
     add hl,hl
     add hl,hl
     push hl
     ld a,h
     inc a
     cpl
     and 3
     ld b,a
     ld a,l
     dec a
     cpl
     ld c,a
     ld de,(TempWord1)
     add hl,de
     ldir
     pop bc
ZeroMemF:
     xor a
SetMemF:
     ld (de),a
     ld h,d \ ld l,e
     inc de
     ld a,b
     or c
     ret z
     ldir
     ret
ShiftGraphRightA:
     rrca
     push af
     call c,ShiftRight1
     pop af
     rrca
     push af
     call c,ShiftRight2
     pop af
     rrca
     push af
     call c,ShiftRight4
     pop af
     rrca
     push af
     call c,ShiftRight8
     pop af
     rrca
     push af
     call c,ShiftRight16
     pop af
     rrca
     push af
     call c,ShiftRight32
     pop af
     rrca
     ret nc
ShiftRight64:
     ld hl,(TempWord1)
     ld a,l
     sub 9
     jr nc,$+3
     dec h
     ld l,a
     ld a,4
     jr ShiftRight8OrMore
ShiftRight32:
     ld hl,(TempWord1)
     ld a,l
     sub 5
     jr nc,$+3
     dec h
     ld l,a
     ld a,8
     jr ShiftRight8OrMore
ShiftRight16:
     ld hl,(TempWord1)
     dec hl \ dec hl \ dec hl
     ld a,10
ShiftRight8OrMore:
     inc h
     inc h
     inc h
     ld b,0
     ld c,a
     ld (TempWord3),bc
     sub 13
     cpl
     ld (TempWord2+1),a
     ld b,64
     ld de,(TempWord1)
     inc d \ inc d \ inc d
     dec de
SR8OMLoop:
;TempWord2==number of bytes to clear
;TempWord3==number of bytes to shift
;b=64
       push bc
       ld bc,(TempWord3)
       lddr
       ld bc,(TempWord2)
       xor a
         ld (de),a
         dec de
         dec hl
         djnz $-3
       pop bc
       djnz SR8OMLoop
     ret
ShiftRight8:
     ld hl,(TempWord1)
     ld d,64
       xor a
       ld b,12
         ld c,(hl)
         ld (hl),a
         inc hl
         ld a,c
         djnz $-4
       dec d
       jr nz,$-10
     ret
ShiftRight2:
     call ShiftRight1
ShiftRight1:
     ld hl,(TempWord1)
     ld c,64
       xor a
       ld b,12
         .dw 1ECBh
         inc hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftRight4:
     ld hl,(TempWord1)
     ld c,64
       xor a
       ld b,12
         .dw 67EDh
         inc hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftGraphLeftA:
     rrca
     push af
     call c,ShiftLeft1
     pop af
     rrca
     push af
     call c,ShiftLeft2
     pop af
     rrca
     push af
     call c,ShiftLeft4
     pop af
     rrca
     push af
     call c,ShiftLeft8
     pop af
     rrca
     push af
     call c,ShiftLeft16
     pop af
     rrca
     push af
     call c,ShiftLeft32
     pop af
     rrca
     ret nc
ShiftLeft64:
     ld hl,(TempWord1)
     ld a,8
     add a,l
     jr c,$+3
     inc hl
     ld l,a
     ld a,4
     jr ShiftLeft8OrMore
ShiftLeft32:
     ld hl,(TempWord1)
     inc hl \ inc hl
     inc hl \ inc hl
     ld a,8
     jr ShiftLeft8OrMore
ShiftLeft16:
     ld hl,(TempWord1)
     inc hl \ inc hl
     ld a,10
ShiftLeft8OrMore:
     ld b,0
     ld c,a
     ld (TempWord3),bc
     sub 13
     cpl
     ld (TempWord2+1),a
     ld b,64
     ld de,(TempWord1)
SL8OMLoop:
       push bc
       ld bc,(TempWord3)
       ldir
       ld bc,(TempWord2)
       xor a
         ld (de),a
         inc de
         inc hl
         djnz $-3
       pop bc
       djnz SL8OMLoop
     ret
ShiftLeft8:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld d,64
       xor a
       ld b,12
         ld c,(hl)
         ld (hl),a
         dec hl
         ld a,c
         djnz $-4
       dec d
       jr nz,$-10
     ret
ShiftLeft2:
     call ShiftLeft1
ShiftLeft1:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld c,64
       xor a
       ld b,12
         .dw 16CBh
         dec hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftLeft4:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld c,64
       xor a
       ld b,12
         .dw 6FEDh
         dec hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftGraphDownA:
     ld e,a
     ld l,a
     ld h,0
     ld d,h
     add hl,hl
     add hl,de
     add hl,hl
     add hl,hl
     push hl
     ld a,h
     inc a
     cpl
     and 3
     ld b,a
     ld a,l
     dec a
     cpl
     ld c,a
     ld hl,(TempWord1)
     dec hl
     add hl,bc
     ld de,(TempWord1)
     inc d \ inc d \ inc d
     dec de
     lddr
     pop bc
ZeroMemE:
     xor a
SetMemE:
     ld (de),a
     ld h,d \ ld l,e
     dec de
     lddr
     ret
ScreenWipe:
     call CheckDigit2
     ld e,a                ;duration to pause between each update
     call CheckDigit3
     push af               ;screen wipe method
     call CheckDigit4
     ld d,a                ;type (white,black,invert,reveal)
     call CheckDigit5
     call GetBuffer
     pop bc
;B is the screen wipe direction
;E is the duration
;D is the pixel type
;HL points to the buffer to wipe
CheckSWL:
     djnz CheckSWR
CheckSWR:
     djnz CheckSWU
CheckSWU:
     djnz CheckSWDU
     call DispRowSetUp
     ld c,63
       call DispRow
       call PauseTime
       dec c
       jr nz,$-7
       jp DispRow
CheckSWDU:
     djnz CheckSWLR
     call DispRowSetUp
     ld b,32
SWDULoop:
       push bc
       ld a,b
       add a,31
       ld c,a
       call DispRow
       pop bc
       push bc
       ld a,32
       sub b
       ld c,a
       call DispRow
       call PauseTime
       pop bc
       djnz SWDULoop
       ret
CheckSWLR:
     djnz CheckSWAll
CheckSWAll:
     djnz CheckSWDUC
CheckSWDUC:
     djnz CheckSWLRC
     call DispRowSetUp
     ld b,32
SWDUCLoop:
       ld c,b
       dec c
       push bc
       call DispRow
       pop bc
       push bc
       ld a,63
       sub c
       ld c,a
       call DispRow
       call PauseTime
       pop bc
       djnz SWDUCLoop
       ret
CheckSWLRC:
     djnz CheckSWAllC
CheckSWAllC:
     djnz CheckSWD
       ret
CheckSWD:
     call DispRowSetUp
     ld c,0
       call DispRow
       call PauseTime
       inc c
       bit 6,c
       jr z,$-9
       ret
DispRow:
;Inputs:
;     C is the row number
;     DE points to the buffer
     push de
     ld a,c
     add a,80h
     ld b,0
     ld h,b \ ld l,c
     add hl,bc
     add hl,bc
     add hl,hl
     add hl,hl
     add hl,de
     out (16),a
     LCDDelay()
     ld a,20h
     out (16),a
     ld b,12
LCDRowLoop:
     LCDDelay()
SMC_WipeByte:
     .dw 0
     ld (hl),a
     inc hl
     out (17),a
     djnz LCDRowLoop
     pop de
     ret
PauseTime:
     ld a,8
SMC_PauseTime:
     ld l,1
     djnz $      ;3323
     dec l       ;4
     jr nz,$-3   ;12
     dec a
     jr nz,$-8
     ret
DispRowSetUp:
     ld a,e
     inc a
     ld (SMC_PauseTime+1),a
     ex de,hl
     ld a,h
     ld hl,003Eh    ;alternatively 00AF
     dec a \ jr nz,$+5
     ld hl,FF3Eh
     dec a \ jr nz,$+5
     ld hl,2F7Eh
     dec a \ jr nz,$+5
     ld hl,007Eh
     ld (SMC_WipeByte),hl
     ld a,7
     out (16),a
     ret
CopyBuffer:
     call CheckDigit2
     call GetBuffer
     push hl
     call CheckDigit3
     call GetBuffer
     push hl
     call CheckDigit4
     pop de
     pop hl
     ld bc,300h
     jr z,CopyBuf
       ld a,(de)
       ldi
       dec hl
       ld (hl),a
       inc hl
       jp pe,$-6
       ret
CopyBuf:
     ldir
     ret
MemCheck:
     call CheckDigit3
     ld hl,0
     jr nz,$+19
       bcall(42E5h)    ;MemChk
HLToAns:
       bcall(4792h)
       bcall(4156h)    ;op2 to op1
StoAns:
       bcall(4ABFh)    ;stoans
       ld sp,(SPSave)
       ret
     dec a
     jr nz,3pr
       ld a,(iy+33)
       and 7
       bcall(478Ch)
       jp StoAns
3pr:
     dec a
     jr nz,RAMAvailable
       ld a,82h
       out (6),a
       ld hl,(4002h)
       res 6,h
       ld a,(4001h)
       sub 82h
       rrca
       rrca
       ld d,a
       and $C0
       or h
       ld h,a
       ld a,d
       and 1
       ld e,a
       ld d,0
;DEHL is the amount of RAM 
       ld bc,ExtraRAM-4000h
       sbc hl,bc
       jr nc,$+3
       dec e
       jr Conv32ToAns
RAMAvailable:
     dec a
     ret nz
     ld a,82h
     out (6),a
     ld a,(iy+33)
     and 7
     jr z,HLToAns
     rrca
     rrca
     ld c,a
     and $C0
     ld h,a
     ld l,0
     ld a,c
     and 1
     ld c,a
     ld b,l
;BCHL is the max ram
     push bc
     push hl
     ld a,(4001h)
     ld hl,(4002h)
     res 6,h
     sub 82h
     rrca
     rrca
     ld c,a
     and $C0
     or h
     ld h,a
     ld a,c
     and 1
     ld b,h
     ld c,l
     pop hl
     pop de
;DEHL-ABC
     ld d,a
     ld a,e
     ld e,d
;AHL-DBC
     or a
     sbc hl,bc
     sbc a,d
     ld e,a
     ld d,0
Conv32ToAns:
     call Conv32OP1
     jp StoAns
Clock:
       ld c,45h
       in l,(c)
       inc c
       in h,(c)
       inc c
       in e,(c)
       inc c
       in d,(c)
       jr Conv32ToAns
Conv32OP1:
     ld bc,8478h
Conv32FP:
;     DEHL is the 32-bit value to convert
;     BC is where to output
     ld a,9
     push bc
       push af
       xor a
       ld (bc),a
       inc bc
       pop af
       dec a
       jr nz,$-6
     pop bc
     push bc
     ld (SMC_HL),hl
     ld hl,848Eh
     ld (SMC_32ConvertCount),hl
     ld c,10
Conv32FPLoop:
     .db 21h        ;ld hl,0
SMC_HL:
     .dw 0
     call DEHL_Div_C
     ld (SMC_HL),hl
     ld b,a
     ld a,h
     or l
     or d
     or e
     .db 21h
SMC_32ConvertCount:
     .dw 0
     dec hl
     ld (SMC_32ConvertCount),hl
     ld (hl),b
     jp nz,Conv32FPLoop
     ex de,hl
     ld hl,848Eh
     sbc hl,de
     ld b,l
     pop hl
;A is zero
;B is the size of the digit string
;DE points to where the last digit was written
;HL points to where the stuff gets converted
     ld (hl),a
     ld c,64
     inc hl
     ld a,7Fh
     add a,b
     ld (hl),a
     inc hl
       ld a,(de)
       inc de
       rld
       rl c
       jr nc,$+5
         ld c,64
         inc hl
       djnz $-11
       ret c
       xor a
       rld
       ret
CommandTable:
;Basic commands, 0 to 9
     .dw ClrDraw,FillBufBlack,FillBufInv,DrawHexSprite,DrawSprite,Misc,ShiftScreen,ScreenWipe,CopyBuffer,UpdateLCD
;Status and Miscellaneous 10 to 19
     .dw MemCheck,BatteryCheck,Clock,LCDOnOff,StorePic,RecallPic,0,0,0,0
;Drawing commands, 20 to 29
     .dw Rectangle,PxlCircle,PxlLine,TileMap,Sprite,Polygon,Flood,Pixel,0,0
;Data commands, 30 to 39
     .dw StoVar,DelVar,GetVar,GetArrayElement,GetMatrixElement,GroupToAppvar,UngroupAppvar,ResetExtraRAM
CommandTableEnd:

DEHL_Div_C:
;Inputs:
;     DEHL is a 32 bit value where HL is the upper 16 bits
;     C is the value to divide HLDE by
;Outputs:
;    A is the remainder
;    B is 0
;    C is not changed
;    HLDE is the result of the division
;
     ld b,32
     xor a
       add hl,hl
       rl e \ rl d
       rla
       cp c
       jr c,$+4
         inc l
         sub c
       djnz $-11
     ret
GetBuffer:
     ld hl,9340h
     or a
     ret z
     ld hl,86ECh
     dec a
     ret z
     ld hl,9872h
     dec a
     ret z
     ld b,a
     ld a,(iy+33)
     and 7
     jr nz,$+6
       ld h,a
       ld l,a
       inc a        ;returns nz
       ret
     ld a,82h
     out (6),a
     ld l,80h
     ld a,3Dh
       add a,3
       djnz $-2
     ld h,a
     xor a
     ret
CheckDigit4:
     ld bc,-6
     jr $+5
CheckDigit2:
     ld bc,-7
     ld hl,(ArgLoc)
     add hl,bc
     ld a,(hl)
     and 15
     ret
CheckDigit1:
     ld bc,-7
     jr CheckDigit3+3
CheckDigit5:
     ld bc,-5
     jr $+5
CheckDigit3:
     ld bc,-6
     ld hl,(ArgLoc)
     add hl,bc
     ld a,(hl)
     and 240
     rlca
     rlca
     rlca
     rlca
     ret
LoadIncrement:
     ld de,(ArgLoc)
     ld hl,(ArgCount)
     ld a,h
     cp l
     jr nz,$+5
       ld d,a
       ld e,a
       ret
     dec hl
     ld (ArgCount),hl
     ex de,hl
     call ConvDecAtHL
     ld (ArgLoc),hl
     or 1
     ld a,e
     ret
Conv_OP1:
     ld hl,8478h
ConvDecAtHL:
;Inputs:
;     HL points to the FP number to convert
;Outputs:
;      A is the 8-bit result
;      B is 0
;      C is the value of the last digit
;     DE is the 16-bit result
;     HL is incremented by 9
;Destroys:
     ex de,hl
     ld hl,9
     add hl,de
     push hl
     ex de,hl
     ld a,(hl)
     and 80h
     push af
     inc hl
     ld a,(hl)
     sub 80h
     ld de,0
     jr nc,$+17
       ld c,e
       ld b,e
ConvDone:
       pop af
       jr z,$+9
         ld a,e \ cpl \ ld e,a
         ld a,d \ cpl \ ld d,a
         inc de
       pop hl
       ld a,e
       ret
     ld b,a
     inc b
     inc hl
     ld a,(hl)
ConvDecLoop:
     rlca
     rlca
     rlca
     rlca
     push hl
     ld h,d
     ld l,e
     add hl,hl
     add hl,hl
     add hl,de
     add hl,hl
     ex de,hl
     pop hl
     and 15
     add a,e
     ld e,a
     jr nc,$+3
     inc d
     dec b
     jr z,ConvDone
     ld a,80h
     xor b
     jr z,ConvDone
     ld b,a
     ld a,(hl)
     jp m,ConvDecLoop+4
     inc hl
     jp ConvDecLoop-1
LocateStr1:
     ld hl,$AA04
     ld (8478h),hl
     ld hl,0
     ld (847Ah),hl
     rst 10h
     jr nc,$+11
ErrStr:
       ld hl,0
       ld d,h \ ld e,l
       ld b,h \ ld c,l
       ld a,h
       ret
     ld a,b
     or a
     jr nz,ErrStr
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ret
LCDOnOFF:
     call CheckDigit3
     and 1
     or 2
     out (16),a
     ret
GetPicLoc:
     call CheckDigit3
     call GetBuffer
     in a,(6)
     push hl
     push af
     call LoadIncrement
     ld h,a
     ld l,60h
     ld (8479h),hl
     xor a
     ld (847Bh),a
     rst 10h
     pop hl
     ld a,h
     pop hl
     ret
IncHLMem1:
;                   speed    1 page         total
;
     inc l         ;    4    4*16384        65536
     ret nz        ;11| 5    64*5+16320*11  179840
     inc h         ;    4    4*64           256
     ret po        ;11| 5    11*63+5        698
     ld h,a
     in a,(6)      ;   11    11             11
     inc a         ;    4    4              4
     out (6),a     ;   11    11             11
     ld a,h
     ld h,40h      ;    7    7              7
     ret           ;   10    10             10
FindVarEnG:
;Inputs:
;     B is the type
;     C is the size of the name
;     DE points to the name
;Outputs:
;     c and z flag reset means the var was found (nc,nz)
;     c and z flag set means the var was not found (c,z)
;       A is the page that the var data is on
;       B is the type
;       C is the size of the name
;       DE is the size of the var
;       HL points to the data
     ld hl,ExtraRAM
     ld a,82h
     ld (SMC_NamePtr),de
     out (6),a
FindVarEnGLoop:
     ld a,(hl)
     cp -1
     jr nz,$+9
       inc a
       ld h,a
       ld l,a
       ld d,a
       ld e,a
       scf
       ret
     call IncHLMem1
     cp b          ;check the type
     ld a,(hl)
     push af
     call IncHLMem1
     pop af
     jr nz,TypeNoMatch
       cp c
       jr nz,TypeNoMatch
         .db 11h
SMC_NamePtr:
         .dw 0
         push bc
         ld b,0
CompareNameLoop:
         ex de,hl
         ld a,(de)
         call IncDEMem1
         cpi
         ex de,hl
         jr nz,TypeNoMatch-2
         jp pe,CompareNameLoop
;woo, yay, var is found:
     pop bc
     ld e,(hl)
     call IncHLMem1
     ld d,(hl)
     call IncHLMem1
     in a,(6)
     or a
     ret

     ld a,c
     pop bc
TypeNoMatch:
     add a,l
     ld l,a
     jr nc,$+15
     inc h
     jp pe,$+12
       ld h,a
       in a,(6)
       inc a
       out (6),a
       ld a,h
       ld h,40h
     push bc
     ld c,(hl)
     call IncHLMem1
     ld b,(hl)
     call IncHLMem1
     add hl,bc
     pop bc
     ld a,h
     rlca
     jr nc,FindVarEnGLoop
     rrca
     sub 40h
     ld h,a
     in a,(6)
     inc a
     out (6),a
     jr FindVarEnGLoop
StorePic:
     ld a,82h
     ld (SMC_CopyTo),a
     call GetPicLoc
     push hl
     push af
     jr c,$+5
     bcall(4FC6h)      ;delvararc
     ld a,7            ;pic object
     ld hl,768         ;I want 768 byte pictures, not 756. 756 means we don't get the last row
     bcall(4E70h)      ;create var (the name is in OP1)
     inc de
     inc de
     pop af
     out (6),a
     pop hl
     ld bc,768
     ldir
     ret
RecallPic:
     call GetPicLoc
     ret c
     out (6),a
     dec hl
     ld a,h
     inc hl
     sub 80h
     jr nc,BufferIsFirst3
;this means we are copying to an extra buffer
     in a,(6)
     or a
     ret p           ;This exits if there are no extra buffers
     ld a,b
     or a
     out (6),a
     ex de,hl
;de points to the buf address, still
     jr z,$+6
       ld bc,12
       add hl,bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
CopyMemBank1ToRAM2:
;      A is the flash page to copy from
;     BC is the pic size
;     DE points to the buffer to copy to
;     HL points to the pic data
;     (SMC_CopyTo) contains the page to copy to
     di
     ld (CopyMemBank1ToRAM2Loop+1),a
CopyMemBank1ToRAM2Loop:
     ld a,0           ;SMC
     out (6),a
     ld a,(hl)
     ex af,af'
SMC_CopyTo       equ $+1
     ld a,82h
     out (6),a
     ex af,af'
     ld (de),a
     inc de
     call IncHLMem1
     dec bc
     ld a,b
     or c
     jr nz,CopyMemBank1ToRAM2Loop
     ret
BufferIsFirst3:
     ret m
     ld a,b
     or a
     out (6),a
     ex de,hl
     jr z,$+6
       ld bc,12
       add hl,bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
ReadArc:
     or a
     jr nz,$+5
       ldir
       ret
     push af \ in a,(6)
     ld (SMC_PageBackUp),a
     pop af
     out (6),a
ArcReadLoop:
     dec hl
     call IncHLmem1
     ldi
     jp pe,ArcReadLoop
     in a,(6)
     push af
SMC_PageBackUp      equ $+1
     ld a,0
     out (6),a
     pop af
     ret
Rectangle:
     call CheckDigit3
     call GetBuffer
     push hl
     call LoadIncrement
     push de
     call LoadIncrement
     pop de
     ld d,a
     push de
     call LoadIncrement
     push de
     call LoadIncrement
     pop de
     ld d,a
     push de
     call LoadIncrement
     pop bc
     pop de
     pop hl
     jr $+5
DrawRectToGraph:
     ld hl,9340h
;===============================================================
DrawRectToBuffer:
DrawRect:
;===============================================================
;Inputs:
;     A is the type of rectangle to draw
;        0 =White
;        1 =Black
;        2 =XOR
;        3 =Black border
;        4 =White border
;        5 =XOR border
;        6 =Black border, white inside
;        7 =Black border, XOR inside
;        8 =White border, black inside
;        9 =White border, XOR inside
;        10=Shift Up
;        11=Shift Down
;        14=Pixel test rectangle
;        15=Pixel test rectangle border
;     B is the height
;     C is the Y pixel coordinate
;     D is the width in pixels
;     E is is the X pixel coordinate
;===============================================================
     di
     push hl
     pop ix
     ex af,af'
;Check if coords are negative
     ld a,c
     or a
     jp p,$+9
       add a,b
       ret nc
       ret z
       ld b,a
       ld c,0

     ld a,e
     or a
     jp p,$+9
       add a,d
       ret nc
       ret z
       ld d,a
       ld e,0
;Check dimensions
     ld a,b
     or a
     ret z
     jp p,$+6
       neg
       ld b,a
     add a,c
     sub 64
     jr c,$+6
       neg
       add a,b
       ld b,a

     ld a,d
     or a
     ret z
     jp p,$+6
       neg
       ld d,a
     add a,e
     sub 96
     jr c,$+6
       neg
       add a,d
       ld d,a
     ld a,c
     cp 64
     ret nc
     ld a,e
     cp 96
     ret nc
MakePattern:
     push bc
     ld hl,RectData
     ld b,24
     xor a
     ld (hl),a
     inc l
     djnz $-2
     ld hl,RectData
     ld c,RectData+12
     ld a,e
     sub 8
     jr c,$+6
       inc l
       inc c
       jr $-6
     add a,8
     ld e,a
     ld b,a
     inc b
     ld a,d
     add a,e
     ld e,a
     ld a,1
     rrca
     djnz $-1
     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     scf
     adc a,a
     ld (hl),a
     ld a,e
     sub 8
     jr c,$+10
     jr z,$+10
       inc l
       ld (hl),-1
       inc c
       jr $-10
     add a,8

     ld b,a
     or a
     ld a,1
     jr z,$+5
     rrca
     djnz $-1

     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     cpl
     and (hl)
     ld (hl),a
     pop bc
     ld a,b
     ld b,0
     ld h,b
     ld l,c
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     push ix
     pop bc
     add hl,bc
     ld b,a
     ex af,af'
     .db $CB,$67,$28,$10,$D6,$10,$F5,$0E,$18,$11
     .dw RectData
     .db $1A,$2F,$12,$13,$0D,$20,$F9,$F1

     or a
     jr nz,$+13h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$10,$F0,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23
     .db $0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8
     .db $05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$04,$18,$DC

     dec a
     jr nz,$+28h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$10,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$10,$F0,$04,$18,$DA

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE
     .db $77,$13,$23,$0D,$20,$F8,$05,$C8,$05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8
     .db $10,$F1,$04,$18,$DC

     dec a
     jr nz,$+36h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8,$05
     .db $28,$1F,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A
     .db $B6,$77,$13,$23,$0D,$20,$F8,$10,$E1,$04,$18,$CC

     .db $3D,$20,$33,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13
     .db $23,$0D,$20,$F8,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1
     .db $0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18,$CD,$3D,$20,$34,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6
     .db $77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18
     .db $CC,$3D,$20,$35,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1F,$E5
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13
     .db $23,$0D,$20,$F7,$10,$E1,$04,$18,$CB,$3D,$20,$37,$05,$C8,$F3,$E5,$D9,$01,$0C,$00,$E1,$09,$D9,$0E
     .db $0C,$11
     .dw RectData
     .db $D5,$D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$13,$23,$D9,$77,$13,$23,$0D,$20
     .db $EF,$10,$E4,$0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$FB,$C9

     .db $3D,$20,$40,$F3,$C5
     .db $11,$0C,$00,$19,$10,$FD,$2B,$E5,$D9,$11,$F4,$FF,$E1,$19,$D9,$C1,$05,$C8,$0E,$0C,$11
     .dw RectData+11
     .db $D5
     .db $D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$1B,$2B,$D9,$77,$1B,$2B,$0D,$20,$EF,$10,$E4,$0E,$0C
     .db $11
     .dw RectData+11
     .db $1A,$2F,$A6,$77,$1B,$2B,$0D,$20,$F7,$FB,$C9

     dec a
     ret z
     dec a
     ret z
     exx
     ld de,0
     ld c,8
     exx
PxlTestRect:
     dec a
     jr nz,PxlTestBorder
     ld c,12
     ld de,RectData
PxlTstRectLoop:
       call PxlTestWithMask
       djnz PxlTstRectLoop-5
       exx
     ex de,hl
     ld de,0
     jp Conv32ToAns
PxlTestBorder:
     dec a
     ret nz
     ld c,12
     ld de,RectData
     call PxlTestWithMask
     dec b
     jr z,PxlTestBorder-4
     dec b
     jr z,PxlTestBrdrEnd
     ld c,12
     ld de,RectData+12
PxlTstBrdrLoop:
       call PxlTestWithMask
       djnz PxlTstBrdrLoop-5
PxlTestBrdrEnd:
     ld de,RectData
     ld c,12
     call PxlTestWithMask
     exx
     ex de,hl
     ld de,0
     jp Conv32ToAns
PxlTestWithMask:
     ld a,(de)
     and (hl)
     exx
     ld b,c
     add a,a
     jr nc,$+3
     inc de
     jr z,$+4
     djnz $-6
     exx
     inc de
     inc hl
     dec c
     jr nz,PxlTestWithMask
     ret
PxlCircle:
     call CheckDigit3
     call GetBuffer
     ld (TempWord5),hl
     call LoadIncrement
     push de
     call LoadIncrement
     pop bc
     ld b,e
     push bc
     call LoadIncrement
     push de
     call LoadIncrement
     pop bc
     pop de
Circle:
;===============================================================
;Input:
;     D = center_x
;     E = center_y
;     C = radius
;     A = method
;Outputs:
;===============================================================
     di
     and 3
     ld (TempWord1),a
     ld a,c
     or a \ ret z
     ret m
     ld h,c     ;h is radius
     ld l,0
     ld b,-1
     ld (TempWord3),de
DrawLoop:
     ex af,af'
     call Plot4Pix
     call Plot4Pix
     ex af,af'
     inc l
     inc b \ inc b
     sub b
     jr nc,$+6
       add a,c
       add a,c
       dec h
       inc b
     ld d,a
     ld a,h \ sub l
     ld a,d
     jr nc,DrawLoop
     ret
Plot4Pix:
     ld de,(TempWord3)
     ld a,h \ ld h,l \ ld l,a
     ld a,d \ add a,h \ ld d,a
     ld a,e \ add a,l \ ld e,a
     call PixelSet
     push de
     ld a,d \ sub h \ sub h \ ld d,a
     call PixelSet
     ld a,e \ sub l \ sub l \ ld e,a
     call PixelSet
     pop de
     ld a,e \ sub l \ sub l \ ld e,a
PixelSet:
;     DE = (x,y)
        ld a,(TempWord1)
     push de
     exx
     pop bc
     ld d,a
     call PlotPixel
     exx
     ret
Pixel:
     call CheckDigit3
     and 3
     push af
     call CheckDigit4
     call GetBuffer
     ld (TempWord5),hl
     call GetCoord
     ld b,d
     ld c,e
     call GetPixelLoc
     ld hl,2
     pop de
     jp nc,HLToAns
     push af
     dec l
     and (hl)
     jr z,$+3
     dec l
     pop af
     dec d
     jr nz,$+3
       or (hl)
     dec d
     jr nz,$+3
       xor (hl)
     dec d
     jr nz,$+4
       cpl
       and (hl)
     jp HLToAns
PlotPixel:
     call GetPixelLoc
     ret nc
     inc d
     dec d
     jr nz,$+6
       cpl \ and (hl) \ ld (hl),a
       ret
     dec d
     jr nz,$+5
       or (hl) \ ld (hl),a
       ret
     dec d
     ret nz
      xor (hl) \ ld (hl),a \ ret
GetCoord:
     call LoadIncrement
     push de
     call LoadIncrement
     pop bc
     ld d,c
     ret
PxlLine:
     call CheckDigit3
     call GetBuffer
     ld (TempWord5),hl
     call GetCoord
     push de
     call GetCoord
     push de
     call LoadIncrement
PatternSpeced:
     pop de
     pop hl
DrawPxlLine:
;     h=x1
;     l=y1
;     d=x2
;     e=y2
     ld c,a
     ld a,d
     sub h
     ld d,a
     ld a,e
     sub l
     ld e,a
     ld a,c
;=====================================
DrawLine:
;     H is X1
;     L is Y1
;     D is width
;     E is height
;     A is the method
;        0 = Pxl-Off
;        1 = Pxl-On
;        2 = PxlInvert
;        3 = 
;=====================================
     di
     and 3
     .db 01h \ cpl \ and (hl)
     dec a
     jr nz,$+5
     .db 01h \ or (hl) \ nop
     dec a
     jr nz,$+5
     .db 01h \ xor (hl) \ nop
     ld (PlotLinePix+1),bc
     ld c,0
     ld a,d
     bit 7,a
     jr z,$+7
       neg
       set 6,c
       ld d,a
     ld a,e
     bit 7,a
     jr z,$+7
       neg
       set 7,c
       ld e,a
     ld b,a
     ex af,af'
     ld a,c
       exx
       rla
       ld de,12
       ld bc,1
       jr nc,$+5
         ld de,-12
       rla
       jr nc,$+4
         dec bc \ dec bc
       exx
     ld a,h
     push hl
     push bc
     ld h,0
     ld b,h
     ld c,l
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     ld c,a
     sra c
     sra c
     sra c
     jp p,$+4
       dec b
     add hl,bc
     ld bc,(TempWord5)
     add hl,bc
     and 7
     ld b,a
     ld a,80h
     jr z,$+5
       rrca
       djnz $-1
     push hl
     exx
     pop hl
     exx
     ex af,af'
     pop bc
     pop hl

     sla e
     jr nz,$+12
       ld b,d
         call DrawLinePixel
         call ChangeX
         djnz $-6
         ret
     sla d
;a is the width/2
;d is width
;e is height
;b is the height
;c is the method
;h is X
;l is Y
DrawLineLoop:
     call DrawLinePixel
     sub d
     jr c,subline
     call ChangeY
     djnz DrawLineLoop
     ret
subline:
     call ChangeX
     add a,e
     jr c,$+8
     call DrawLinePixel
     jp subline
     call ChangeY
     djnz DrawLineLoop
     ret
ChangeY:
   exx
   add hl,de
   exx
   inc l
   bit 7,c
   jr z,$+4
   dec l \ dec l
   ret
ChangeX:
   ex af,af'
   rrca
   inc h
   bit 6,c
   jr z,$+6
   dec h \ dec h \ rlca \ rlca
   jr nc,$+5
     exx
     add hl,bc
     exx
   ex af,af'
   ret
DrawLinePixel:
     push af
     ld a,l
     cp 64
     jr nc,ExitDrawPixel
     ld a,h
     cp 96
     jr nc,ExitDrawPixel
     ex af,af'
     exx
PlotLinePix:
     push af
     nop
     or (hl)
     ld (hl),a
     pop af
     exx
     ex af,af'
ExitDrawPixel:
     pop af
     ret
Polygon:
     call CheckDigit3
     call GetBuffer
     ld (TempWord5),hl
     call LoadIncrement
     push de
     call LoadIncrement
     ld (SMC_PolgonMethod),a
     call GetCoord
     pop bc
PolygonLoop:
;     BC is the number of edges
;     DE points to the first coordinate
     push bc
     push de
     call GetCoord
     pop hl
     push de
     .db 3Eh           ;ld a,*
SMC_PolgonMethod:
     .db 0
     call DrawPxlLine
     pop de
     pop bc
     dec bc
     ld a,b
     or c
     jr nz,PolygonLoop
     ret
SubCode00:
     ld a,(hl)
     ld (de),a
     call IncDEMem1
     cpi
     ret
StoVar:
;Returns errors:
;     0 means no extra RAM pages
;     1 means success
;     2 means Str1 was archived or doesn't exist
;     3 means not enough RAM
;     4 means the name is too long
;     5 means the var already exists
     ld a,(iy+33)
     or a
     jp z,SetAns0
     ld a,82h
     out (6),a
     call CheckDigit3
     push af
     ld (SMC_01),a
     call LocateStr1   ;must be in RAM
     di
     ld a,h
     or l
     jp z,SetAns2
;BC is the number of bytes in Str1
;HL poins to the data of Str1
     push hl
     .db 11h,0
SMC_01:
     .db 0
     ld a,3Eh
       cpi
       jp pe,$+6
         inc e
         jr $+10
       jr z,$+8
       inc e
       jp z,SetAns4
       jr $-14
     ld (SMC_NumBytesLeft),bc
     ld b,d
     ld c,e
     ld a,e
     ld (SMC_NameLength),a
     pop de
     push de
     call FindVarEnG
     jp nc,SetAns5

     pop hl
     ld de,(4002h)
     ld a,(4001h)
     out (6),a
     pop af
     ld (de),a
     ld a,c
     inc de
     ld (de),a
     inc de
     .db 1
SMC_NameLength:
     .dw 0
CopyName:
;hl points to the name
;DE points to MemBank1
;BC is the length of the name
     call SubCode00
     jp po,CopyData
     call Is_2_Byte
     jr nz,CopyName
     call SubCode00
     jp pe,CopyName
CopyData:
;DE points to where the size bytes will be copied
;HL points to the : in the string
;BC is the number of bytes left in the string
  ex de,hl
  .db 1
SMC_NumBytesLeft:
  .dw 0
  ld (hl),c
  call IncHLMem1
  ld (hl),b
  call IncHLMem1
  inc de
  ld a,b
  or c
  ex de,hl
     jp z,FillSizeBytes
;DE points to where to copy the data
;HL points to the data to copy
;B'C' is the size of the data
CopyDataLoop:
     ldi
     jp po,FillSizeBytes
     dec de
     call IncDEMem1
     jr CopyDataLoop
FillSizeBytes:
     ex de,hl
     ld (hl),-1
     in a,(6)
     ld d,a
     ld a,82h
     out (6),a
     ld a,d
     ld (4001h),a
     ld (4002h),hl
SetAns1:
     ld hl,1
     jp HLToAns
SetAns5:
     ld hl,5
     jp HLToAns
SetAns4:
     ld hl,4
     jp HLToAns
SetAns3:
     ld hl,3
     jp HLToAns
SetAns2:
     ld hl,2
     jp HLToAns
SetAns0:
     ld hl,0
     jp HLToAns
DelVar:
     call CheckDigit3     ;get the var type
     push af
     call GetNameStr1
     pop af
     ld b,a
     call FindVarEnG
     ret c
     ld b,0
     inc bc
     inc bc
     inc bc
     inc bc
     push de
     push bc
     sbc hl,bc
     ld b,a
     ld a,h
     sub 40h
     jr nc,$+6
       sub 80h
       ld h,a
       dec b
     ex de,hl
     pop hl
     ld a,b
     pop bc
     add hl,bc
;now ADE is the location of the var
;HL is the number of bytes to remove
DelMemEnG:
;     ADE is where to delete the data
;     HL is the number of bytes to remove
;Output:
;     c flag returned if the RAM is even there
;
;Notes:
;     This deletes memory from RAM. In this case, it deletes
;     from the extra RAM in EnG. This is used to resize
;     EnG variables (or delete them)
     ld c,a
     ld a,h
     or l
     scf
     ret z
     ld a,(iy+33)
     or a
     ret z
     add hl,de
     ld a,c
     jr nc,$+3
     inc c
;At this point, CHL points to the data just after the data to remove
;Now perform MemEnd-CHL and that is how much data to shift
     push de
     push af
     ld a,82h
     out (6),a
     ld a,(4001h)
     ex de,hl
     ld hl,(4002h)
;Ahl = MemEnd
;AHL-CDE
     or a
     sbc hl,de
     sbc a,c
     ex af,af'
     ld a,c
     ld (SMC_FromPage),a
     ex af,af'
     push af
     or h
     or l
     pop ix
     ld b,h
     ld c,l
     pop hl
     ld a,h
     pop hl
     jr z,UpdatePtrs
     inc ixh
;A'DE points to where the data is moved from
;AHL points to where the data gets moved to
;(IXL-1)BC is the number of bytes to shift
DelMemLoop:
     ex af,af'
     push bc
     .db 3Eh
SMC_FromPage:
     .db 0
     out (6),a
     push af
     ld a,(de)
     ld b,a
     pop af
     call IncDEMem1
     in a,(6)
     ld (SMC_FromPage),a
     ex af,af'
     out (6),a
     ld (hl),b
     call IncHLMem1
     pop bc
     dec bc
     ld a,b
     or c
     in a,(6)
     jr nz,DelMemloop
     dec ixh
     jr nz,DelMemLoop
UpdatePtrs:
     ld a,82h
     out (6),a
     ld (4002h),hl
     ld a,(SMC_FromPage)
     ld (4001h),a
     out (6),a
     ld (hl),-1
     ret
GetNameStr1:
;Outputs:
;     DE points to the name
;     C is the name length
     call LocateStr1
     push hl
     ld de,3Eh
GetNamePartLoop:
       ld a,(hl)
       call Is_2_Byte
       jr nz,$+11
         cpi
         inc d
         inc d
         cpi
         jp pe,GetNamePartLoop
       ld a,e
       cpi
       jp po,$+8
       jr z,$+6
       inc d
       jr GetNamePartLoop
       inc d
     ld c,d
     pop de
     ret
GetVar:
     call CheckDigit3     ;get the var type
     push af
     call GetNameStr1
     pop af
     ld b,a
     call FindVarEnG
;     ret c
     push hl
     push af
     push de
     bcall(4B52h)
     rst 10h
     bcall(4FC9h)
     pop hl
     push hl
     bcall(4327h)
     inc de
     inc de
     pop bc
     pop hl
     ld a,b
     or c
     ld a,h
     pop hl
     jp nz,ReadArc
     ret
GetArrayElement  equ 0
GetMatrixElement equ 0
GroupToAppvar    equ 0
UngroupAppvar    equ 0
Flood            equ 0
TileMap          equ 0
Sprite           equ 0
BatteryCheck     equ 0
ResetExtraRAM:
     ld a,(iy+33)
     or a
     jp z,SetAns0
     ld a,82h
     out (6),a
     ld (4001h),a
     ld hl,ExtraRAM
     ld (4002h),hl
     ld (hl),-1
     jp SetAns1
IncDEMem1:
;                   speed    1 page         total
;
     inc e         ;    4    4*16384        65536
     ret nz        ;11| 5    64*5+16320*11  179840
     inc d         ;    4    4*64           256
     ret pe        ;11| 5    11*63+5        698
     ld d,a
     in a,(6)      ;   11    11             11
     inc a         ;    4    4              4
     out (6),a     ;   11    11             11
     ld a,d
     ld d,40h      ;    7    7              7
     ret           ;   10    10             10
;===============================================================
Is_2_Byte:
;===============================================================
          sub $EF \ ret z        ;ef
          add a,34h \ ret z      ;bb
          add a,3Dh \ ret z      ;7E
Is_Var_Name:
;Before calling this, add 82h to a
          sub 2Ch \ ret z        ;AA
          add a,47h \ ret z      ;63
          inc a \ ret z
          inc a \ ret z
          inc a \ ret z
          add a,2 \ ret z
          inc a \ ret z
          inc a \ ret
GetPixelLoc:
;Input:
;     b is X
;     c is y
;Output:
;     HL points to byte
;     A is the mask
;     nc if not computed, c if computed
       ld a,c
       cp 64 \ ret nc
       ld a,b
       cp 96 \ ret nc
       ld l,c
       ld h,0
       ld b,h
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,hl
       ld b,a
       rrca \ rrca \ rrca
       and 0Fh
       ld c,a
       ld a,b
       ld b,0
       add hl,bc
       ld bc,(TempWord5)
       add hl,bc
       and 7
       ld b,a
       inc b
       ld a,1
         rrca
         djnz $-1
       scf
       ret
UpdateLCD:
     call CheckDigit2
     call GetBuffer
;===============================================================
BufferToLCD:
;===============================================================
;Input:
;     HL points to the buffer to copy to the LCD
;Outputs:
;
;===============================================================
     di
setrow:
     LCDDelay()
     ld a,$80
     out (16),a
     ld de,12
     ld a,$20
col:
     ld b,a
     LCDDelay()
     ld a,b
     out (10h),a
     push af
     ld b,64
row:
     ld a,(hl)
     add hl,de
     bit 3,(iy+5)
     jr z,$+3
       cpl
     ld c,a
     LCDDelay()
     ld a,c
     out ($11),a
     djnz row

     pop af
     inc a
     dec h
     dec h
     dec h
     inc hl

     cp $2c
     jp nz,col
     ret
ParseString:
     ret
